DynaActionForm (Struts Core 1.3.10 API)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts.action
Class DynaActionForm

    java.lang.Object
      org.apache.struts.action.ActionForm
          org.apache.struts.action.DynaActionForm

All Implemented Interfaces:
  Serializable, DynaBean

Direct Known Subclasses:
  DynaValidatorForm

    public class DynaActionForm

extends ActionForm
implements DynaBean

Specialized subclass of `ActionForm` that allows the creation of form beans with dynamic sets of properties, without requiring the developer to create a Java class for each type of form bean.

USAGE NOTE - Since Struts 1.1, the `reset` method no longer initializes property values to those specified in `<form-property>` elements in the Struts module configuration file. If you wish to utilize that behavior, the simplest solution is to subclass `DynaActionForm` and call the `initialize` method inside it.

Since:
  Struts 1.1
Version:
  $Rev: 471754 $ $Date: 2005-11-12 11:52:08 -0500 (Sat, 12 Nov 2005) $
See Also:
  Serialized Form

Field Summary
`protected DynaActionFormClass` | `dynaClass` The `DynaActionFormClass` with which we are associated.
`protected HashMap` | `dynaValues` The set of property values for this `DynaActionForm`, keyed by property name.

Fields inherited from class org.apache.struts.action.ActionForm
`multipartRequestHandler, servlet`

Constructor Summary
`DynaActionForm()`

Method Summary
`boolean` | `contains(String name, String key)` Indicates if the specified mapped property contain a value for the specified key value.
`Object` | `get(String name)` Return the value of a simple property with the specified name.
`Object` | `get(String name, int index)` Return the value of an indexed property with the specified name.
`Object` | `get(String name, String key)` Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.
`DynaClass` | `getDynaClass()` Return the `DynaClass` instance that describes the set of properties available for this `DynaBean`.
`protected DynaProperty` | `getDynaProperty(String name)` Return the property descriptor for the specified property name.
`Map` | `getMap()` Returns the `Map` containing the property values.
`String` | `getString(String name)` Return the value of a `String` property with the specified name.
`String[]` | `getStrings(String name)` Return the value of a `String[]` property with the specified name.
`void` | `initialize(ActionMapping mapping)` Initialize all bean properties to their initial values, as specified in the `FormPropertyConfig` elements associated with the definition of this `DynaActionForm`.
`void` | `initialize(FormBeanConfig config)` Initialize the specified form bean.
`protected boolean` | `isDynaAssignable(Class dest, Class source)` Indicates if an object of the source class is assignable to the destination class.
`void` | `remove(String name, String key)` Remove any existing value for the specified key on the specified mapped property.
`void` | `reset(ActionMapping mapping, HttpServletRequest request)` Reset the properties to their `initial` value if their `reset` configuration is set to true or if `reset` is set to a list of HTTP request methods that includes the method of given `request` object.
`void` | `reset(ActionMapping mapping, ServletRequest request)` Reset bean properties to their default state, as needed.
`void` | `set(String name, int index, Object value)` Set the value of an indexed property with the specified name.
`void` | `set(String name, Object value)` Set the value of a simple property with the specified name.
`void` | `set(String name, String key, Object value)` Set the value of a mapped property with the specified name.
`String` | `toString()` Render a String representation of this object.

Methods inherited from class org.apache.struts.action.ActionForm
`getMultipartRequestHandler, getServlet, getServletWrapper, setMultipartRequestHandler, setServlet, validate, validate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### dynaClass

    protected DynaActionFormClass dynaClass

  The `DynaActionFormClass` with which we are associated.

### dynaValues

    protected HashMap dynaValues

  The set of property values for this `DynaActionForm`, keyed by property name.

Constructor Detail

### DynaActionForm

    public DynaActionForm()

Method Detail

### initialize

    public void initialize(ActionMapping mapping)

  Initialize all bean properties to their initial values, as specified in the `FormPropertyConfig` elements associated with the definition of this `DynaActionForm`.

  Parameters:
    `mapping` - The mapping used to select this instance

### initialize

    public void initialize(FormBeanConfig config)

  Initialize the specified form bean.

  Parameters:
    `config` - The configuration for the form bean to initialize.

### reset

    public void reset(ActionMapping mapping,
                      ServletRequest request)

  Reset bean properties to their default state, as needed. This method is called before the properties are repopulated by the controller.

  The default implementation attempts to forward to the HTTP version of this method.

  Overrides:
    `reset` in class `ActionForm`
  Parameters:
    `mapping` - The mapping used to select this instance
    `request` - The servlet request we are processing

### reset

    public void reset(ActionMapping mapping,
                      HttpServletRequest request)

  Reset the properties to their `initial` value if their `reset` configuration is set to true or if `reset` is set to a list of HTTP request methods that includes the method of given `request` object.

  Overrides:
    `reset` in class `ActionForm`
  Parameters:
    `mapping` - The mapping used to select this instance
    `request` - The servlet request we are processing

### contains

    public boolean contains(String name,
                            String key)

  Indicates if the specified mapped property contain a value for the specified key value.

  Specified by:
    `contains` in interface `DynaBean`
  Parameters:
    `name` - Name of the property to check
    `key` - Name of the key to check
  Returns:
    `true` if the specified mapped property contains a value for the specified key value; `true` otherwise.
  Throws:
    `NullPointerException` - if there is no property of the specified name
    `IllegalArgumentException` - if there is no mapped property of the specified name

### get

    public Object get(String name)

  Return the value of a simple property with the specified name.

  Specified by:
    `get` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
  Returns:
    The value of a simple property with the specified name.
  Throws:
    `IllegalArgumentException` - if there is no property of the specified name
    `NullPointerException` - if the type specified for the property is invalid

### get

    public Object get(String name,
                      int index)

  Return the value of an indexed property with the specified name.

  Specified by:
    `get` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
    `index` - Index of the value to be retrieved
  Returns:
    The value of an indexed property with the specified name.
  Throws:
    `IllegalArgumentException` - if there is no property of the specified name
    `IllegalArgumentException` - if the specified property exists, but is not indexed
    `NullPointerException` - if no array or List has been initialized for this property

### get

    public Object get(String name,
                      String key)

  Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.

  Specified by:
    `get` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
    `key` - Key of the value to be retrieved
  Returns:
    The value of a mapped property with the specified name, or `null` if there is no value for the specified key.
  Throws:
    `NullPointerException` - if there is no property of the specified name
    `IllegalArgumentException` - if the specified property exists, but is not mapped

### getString

    public String getString(String name)

  Return the value of a `String` property with the specified name. This is equivalent to calling `(String) dynaForm.get(name)`.

  Parameters:
    `name` - Name of the property whose value is to be retrieved.
  Returns:
    The value of a `String` property with the specified name.
  Throws:
    `IllegalArgumentException` - if there is no property of the specified name
    `NullPointerException` - if the type specified for the property is invalid
    `ClassCastException` - if the property is not a String.
  Since:
    Struts 1.2

### getStrings

    public String[] getStrings(String name)

  Return the value of a `String[]` property with the specified name. This is equivalent to calling `(String[]) dynaForm.get(name)`.

  Parameters:
    `name` - Name of the property whose value is to be retrieved.
  Returns:
    The value of a `String[]` property with the specified name.
  Throws:
    `IllegalArgumentException` - if there is no property of the specified name
    `NullPointerException` - if the type specified for the property is invalid
    `ClassCastException` - if the property is not a String[].
  Since:
    Struts 1.2

### getDynaClass

    public DynaClass getDynaClass()

  Return the `DynaClass` instance that describes the set of properties available for this `DynaBean`.

  Specified by:
    `getDynaClass` in interface `DynaBean`
  Returns:
    The `DynaClass` instance that describes the set of properties available for this `DynaBean`.

### getMap

    public Map getMap()

  Returns the `Map` containing the property values. This is done mostly to facilitate accessing the `DynaActionForm` through JavaBeans accessors, in order to use the JavaServer Pages Standard Tag Library (JSTL).

  For instance, the normal JSTL EL syntax for accessing an `ActionForm` would be something like this:

        ${formbean.prop}

  The JSTL EL syntax for accessing a `DynaActionForm` looks something like this (because of the presence of this `getMap()` method):

        ${dynabean.map.prop}

  Returns:
    The `Map` containing the property values.

### remove

    public void remove(String name,
                       String key)

  Remove any existing value for the specified key on the specified mapped property.

  Specified by:
    `remove` in interface `DynaBean`
  Parameters:
    `name` - Name of the property for which a value is to be removed
    `key` - Key of the value to be removed
  Throws:
    `NullPointerException` - if there is no property of the specified name
    `IllegalArgumentException` - if there is no mapped property of the specified name

### set

    public void set(String name,
                    Object value)

  Set the value of a simple property with the specified name.

  Specified by:
    `set` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `value` - Value to which this property is to be set
  Throws:
    `ConversionException` - if the specified value cannot be converted to the type required for this property
    `IllegalArgumentException` - if there is no property of the specified name
    `NullPointerException` - if the type specified for the property is invalid
    `NullPointerException` - if an attempt is made to set a primitive property to null

### set

    public void set(String name,
                    int index,
                    Object value)

  Set the value of an indexed property with the specified name.

  Specified by:
    `set` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `index` - Index of the property to be set
    `value` - Value to which this property is to be set
  Throws:
    `ConversionException` - if the specified value cannot be converted to the type required for this property
    `NullPointerException` - if there is no property of the specified name
    `IllegalArgumentException` - if the specified property exists, but is not indexed
    `IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property

### set

    public void set(String name,
                    String key,
                    Object value)

  Set the value of a mapped property with the specified name.

  Specified by:
    `set` in interface `DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `key` - Key of the property to be set
    `value` - Value to which this property is to be set
  Throws:
    `NullPointerException` - if there is no property of the specified name
    `IllegalArgumentException` - if the specified property exists, but is not mapped

### toString

    public String toString()

  Render a String representation of this object.

  Overrides:
    `toString` in class `Object`
  Returns:
    A string representation of this object.

### getDynaProperty

    protected DynaProperty getDynaProperty(String name)

  Return the property descriptor for the specified property name.

  Parameters:
    `name` - Name of the property for which to retrieve the descriptor
  Returns:
    The property descriptor for the specified property name.
  Throws:
    `IllegalArgumentException` - if this is not a valid property name for our DynaClass

### isDynaAssignable

    protected boolean isDynaAssignable(Class dest,
                                       Class source)

  Indicates if an object of the source class is assignable to the destination class.

  Parameters:
    `dest` - Destination class
    `source` - Source class
  Returns:
    `true` if the source is assignable to the destination; `false` otherwise.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.